from django.shortcuts import render ,redirect
from detailsretour.models import DetailRetour 
from retours.models import Retour
import decimal
from django.contrib import messages
from avisreceptions.models import Avis_de_reception
from articles.models import Article
from lots.models import Lot
from detailavisderecepetions.models import detailAvisRecepetion
from django.contrib.auth.decorators import login_required
# Create your views here.


@login_required(login_url="/login/")
def formulaire_avis_reception(request):
	context = {}
	details_recu = []
	if request.method == "POST":
		id_retour = request.POST.get('id_retour')
		numf = Avis_de_reception.objects.all().order_by('numero_reception').reverse().first()
		if numf  :
			num = '00'+ str(int(numf.numero_reception) + 1)
		else :
			num  = '001'
		context['numero_reception'] = num

	list_detail_recu = DetailRetour.objects.filter(retour_id = id_retour)
	for detail in list_detail_recu:
		renvoye = detail.quantitee_renvoyee
		recu = detail.quantitee_recu
		if renvoye > recu:
			details_recu.append(detail)

	context['list_detail_recu'] = details_recu
	context['id_retour'] = id_retour
	return render(request, 'ajouter_avis_reception.html', context)

@login_required(login_url="/login/")
def ajouter_avis_de_reception(request):
	context = {}
	total_quantite_recu = 0
	continuer = True
	if request.method == "POST":
		date_reception = request.POST.get('date_reception')
		numero_reception = request.POST.get('numero_reception')
		remarque = request.POST.get('remarque')
		user = request.POST.get('user')
		id_commande = request.POST.get('id_commande')
		quantitee_recu = request.POST.getlist('quantitee_recu[]')
		id_detail_recu = request.POST.getlist('id_detail_recu[]')
		id_retour = request.POST.get('id_retour')

	for i in range(len(id_detail_recu)):
		quantitee_renvoyee_quantitee_recu = DetailRetour.objects.get(id = id_detail_recu[i]).quantitee_renvoyee_quantitee_recu
		print("quantitee_renvoyee_quantitee_recu", quantitee_renvoyee_quantitee_recu)
		print("quantitee_recu[i])", quantitee_recu[i])
		if decimal.Decimal(quantitee_recu[i])> quantitee_renvoyee_quantitee_recu:
			continuer = False
	if continuer:
		avis_reception = Avis_de_reception(numero_reception=numero_reception,date_reception = date_reception, retour_id = id_retour, remarque = remarque  )
		avis_reception.save()
		print("Longueur de liste = ", len(id_detail_recu))
		for i in range(len(id_detail_recu)):
			detail_avis_reception = detailAvisRecepetion(avis_reception = avis_reception,quantitee_recu =decimal.Decimal(quantitee_recu[i]),detail_Retour_id = id_detail_recu[i]  )
			detail_avis_reception.save() 

			quantitee_recu_ancienne = DetailRetour.objects.get(id =decimal.Decimal(id_detail_recu[i])).quantitee_recu
			DetailRetour.objects.filter(id =decimal.Decimal(id_detail_recu[i])).update(quantitee_recu = quantitee_recu_ancienne + decimal.Decimal(quantitee_recu[i]) )
			quantitee_recu_nouvelle = DetailRetour.objects.get(id =decimal.Decimal(id_detail_recu[i])).quantitee_recu
			quantitee_renvoyee = DetailRetour.objects.get(id =decimal.Decimal(id_detail_recu[i])).quantitee_renvoyee
			DetailRetour.objects.filter(id =decimal.Decimal(id_detail_recu[i])).update(quantitee_renvoyee_quantitee_recu =quantitee_renvoyee - quantitee_recu_nouvelle )
			id_article = DetailRetour.objects.get(id =decimal.Decimal(id_detail_recu[i])).article_commandee.article.id
			id_lot = DetailRetour.objects.get(id =decimal.Decimal(id_detail_recu[i])).article_commandee.lot.id
			stock_physique_disponible_ancien = Article.objects.get(id = id_article).stock_physique_disponible
			stock_physique_disponible_a_la_vente_ancien = Article.objects.get(id = id_article).stock_physique_disponible_a_la_vente
			Article.objects.filter(id = id_article).update(stock_physique_disponible = stock_physique_disponible_ancien + decimal.Decimal(quantitee_recu[i]))
			Article.objects.filter(id = id_article).update(stock_physique_disponible_a_la_vente = stock_physique_disponible_a_la_vente_ancien + decimal.Decimal(quantitee_recu[i]))
			quantitee_ancien = Lot.objects.get(id = id_lot).quantitee
			Lot.objects.filter(id = id_lot).update(quantitee = quantitee_ancien + decimal.Decimal(quantitee_recu[i]))


			total_quantite_recu = total_quantite_recu + decimal.Decimal(quantitee_recu[i])

		quantitee_renvoyee = Retour.objects.get(id = id_retour).quantitee_renvoyee
		quantitee_recu_retour_ancienne = Retour.objects.get(id = id_retour).quantitee_recu
		Retour.objects.filter(id = id_retour).update(quantitee_recu = total_quantite_recu + quantitee_recu_retour_ancienne)
		quantitee_recu_retour_nouvelle = Retour.objects.get(id = id_retour).quantitee_recu
		
		if quantitee_renvoyee > quantitee_recu_retour_nouvelle:
			Retour.objects.filter(id = id_retour).update(staut_reception = "Partiellement")
		else:
			if quantitee_renvoyee == quantitee_recu_retour_nouvelle:
				Retour.objects.filter(id = id_retour).update(staut_reception = "Complettement reçu")

		messages.success(request, "Avis de reception bien crée")
	else:
		messages.error(request, "Erreur de la valeur réçue")


	return render(request, 'ajouter_avis_reception.html', context)

@login_required(login_url="/login/")
def detail_avis_reception(request):
	context = {}
	if request.method == "POST":
		id_avis_reception = request.POST.get("id_avis_reception")

	context['detail_avis_receptions'] = detailAvisRecepetion.objects.filter(avis_reception_id = id_avis_reception)
	context['avis_reception'] = Avis_de_reception.objects.get(id = id_avis_reception )
	
	return render(request, 'detail-avis-reception.html', context)

@login_required(login_url="/login/")
def modifier_avis_reception_retour(request):
	context = {}
	if request.method == "POST":
		id_avis_reception = request.POST.get('id_avis_reception')
		avis_de_reception = Avis_de_reception.objects.get(id = id_avis_reception)

		context['avis_reception'] =  Avis_de_reception.objects.get(id = id_avis_reception)
		context['details_avis_de_reception'] = detailAvisRecepetion.objects.filter(avis_reception_id = id_avis_reception)

	return render(request, 'modifier-avis-reception.html', context)
@login_required(login_url="/login/")
def valider_modifier_avis_reception_retour(request):
	context = {}
	if request.method == "POST":
		id_avis_reception = request.POST.get('id_avis_reception')
		avis_de_reception = Avis_de_reception.objects.get(id = id_avis_reception)
		retour = Retour.objects.get(id = avis_de_reception.retour.id)
		date_reception = request.POST.get('date_reception')
		remarque = request.POST.get('remarque')

		Avis_de_reception.objects.filter(id = id_avis_reception).update(date_reception = date_reception)
		Avis_de_reception.objects.filter(id = id_avis_reception).update(remarque = remarque)

		quantitee_recu = request.POST.getlist('quantitee_recu[]')
		id_detail_recu = request.POST.getlist('id_detail_recu[]')
		id_article_recu_supprimer = request.POST.getlist('id_article_recu_supprimer[]')
		for i in range(len(id_detail_recu)):
			detailavisrecepetion = detailAvisRecepetion.objects.get(id = id_detail_recu[i])
			detailsretour = DetailRetour.objects.get(id = detailavisrecepetion.detail_Retour.id)

			id_article = DetailRetour.objects.get(id =detailsretour.id).article_commandee.article.id
			id_lot = DetailRetour.objects.get(id =detailsretour.id).article_commandee.lot.id

			if detailavisrecepetion.quantitee_recu >= decimal.Decimal(quantitee_recu[i]) :
				dif = detailavisrecepetion.quantitee_recu - decimal.Decimal(quantitee_recu[i])
				new_quantitee_recu = detailsretour.quantitee_recu - dif
				new_quantitee_recu_retour = retour.quantitee_recu - dif
				stock_physique_disponible_ancien = Article.objects.get(id = id_article).stock_physique_disponible - dif
				stock_physique_disponible_a_la_vente_ancien = Article.objects.get(id = id_article).stock_physique_disponible_a_la_vente - dif 
				quantitee_ancien = Lot.objects.get(id = id_lot).quantitee - dif

			else :
				dif =  decimal.Decimal(quantitee_recu[i])  - detailavisrecepetion.quantitee_recu 
				new_quantitee_recu = detailsretour.quantitee_recu - dif
				new_quantitee_recu_retour = retour.quantitee_recu + dif
				stock_physique_disponible_ancien = Article.objects.get(id = id_article).stock_physique_disponible + dif
				stock_physique_disponible_a_la_vente_ancien = Article.objects.get(id = id_article).stock_physique_disponible_a_la_vente + dif
				quantitee_ancien = Lot.objects.get(id = id_lot).quantitee +dif
			
			
			Article.objects.filter(id = id_article).update(stock_physique_disponible = stock_physique_disponible_ancien )
			Article.objects.filter(id = id_article).update(stock_physique_disponible_a_la_vente = stock_physique_disponible_a_la_vente_ancien)
			Lot.objects.filter(id = id_lot).update(quantitee = quantitee_ancien)
			DetailRetour.objects.filter(id = detailsretour.id ).update(quantitee_recu = new_quantitee_recu)		
			DetailRetour.objects.filter(id = detailsretour.id ).update(quantitee_renvoyee_quantitee_recu= detailsretour.quantitee_renvoyee - new_quantitee_recu)		
			detailAvisRecepetion.objects.filter(id = id_detail_recu[i]).update(quantitee_recu = quantitee_recu[i])
#supprimer detailAvisReception
		if id_article_recu_supprimer[0] != '' :
			for i in range(len(id_article_recu_supprimer)):
				detailavisrecepetion = detailAvisRecepetion.objects.get(id = id_article_recu_supprimer[i])
				detailsretour = DetailRetour.objects.get(id = detailavisrecepetion.detail_Retour.id)
				id_article = DetailRetour.objects.get(id =detailsretour.id).article_commandee.article.id
				id_lot = DetailRetour.objects.get(id =detailsretour.id).article_commandee.lot.id
				new_quantitee_recu = detailsretour.quantitee_recu - detailavisrecepetion.quantitee_recu
				new_quantitee_recu_retour = retour.quantitee_recu - detailavisrecepetion.quantitee_recu
				stock_physique_disponible_ancien = Article.objects.get(id = id_article).stock_physique_disponible - detailavisrecepetion.quantitee_recu
				stock_physique_disponible_a_la_vente_ancien = Article.objects.get(id = id_article).stock_physique_disponible_a_la_vente - detailavisrecepetion.quantitee_recu 
				quantitee_ancien = Lot.objects.get(id = id_lot).quantitee - detailavisrecepetion.quantitee_recu

				Article.objects.filter(id = id_article).update(stock_physique_disponible = stock_physique_disponible_ancien )
				Article.objects.filter(id = id_article).update(stock_physique_disponible_a_la_vente = stock_physique_disponible_a_la_vente_ancien)
				Lot.objects.filter(id = id_lot).update(quantitee = quantitee_ancien)
				DetailRetour.objects.filter(id = detailsretour.id ).update(quantitee_recu = new_quantitee_recu)		
				DetailRetour.objects.filter(id = detailsretour.id ).update(quantitee_renvoyee_quantitee_recu= detailsretour.quantitee_renvoyee - new_quantitee_recu) 
				detailavisrecepetion.delete()

		Retour.objects.filter(id = retour.id).update(quantitee_recu = new_quantitee_recu_retour)
		quantitee_renvoyee = Retour.objects.get(id = retour.id).quantitee_renvoyee
		quantitee_recu_retour_nouvelle = Retour.objects.get(id = retour.id).quantitee_recu
		
		if quantitee_recu_retour_nouvelle == 0 :
			Retour.objects.filter(id = retour.id).update(staut_reception = " ")
		elif quantitee_renvoyee > quantitee_recu_retour_nouvelle:
			Retour.objects.filter(id = retour.id).update(staut_reception = "Partiellement")
		else:
			if quantitee_renvoyee == quantitee_recu_retour_nouvelle:
				Retour.objects.filter(id = retour.id).update(staut_reception = "Complettement reçu")
		messages.success(request, "Avis de reception bien ajouter")
	return redirect('liste_retours')



@login_required(login_url="/login/")
def supprimer_avis_reception_retour(request):
	context = {}
	if request.method == "POST":
		id_avis_reception = request.POST.get('id_avis_reception')
		avis_de_reception = Avis_de_reception.objects.get(id = id_avis_reception)
		retour = Retour.objects.get(id = avis_de_reception.retour.id)
		detailavisrecepetion = detailAvisRecepetion.objects.filter(avis_reception = avis_de_reception)
		new_quantitee_recu_retour = retour.quantitee_recu
		for i in range(len(detailavisrecepetion)):
			detailsretour = DetailRetour.objects.get(id = detailavisrecepetion[i].detail_Retour.id)
			id_article = DetailRetour.objects.get(id =detailsretour.id).article_commandee.article.id
			id_lot = DetailRetour.objects.get(id =detailsretour.id).article_commandee.lot.id
			new_quantitee_recu = detailsretour.quantitee_recu - detailavisrecepetion[i].quantitee_recu	
			new_quantitee_recu_retour = new_quantitee_recu_retour - detailavisrecepetion[i].quantitee_recu
			stock_physique_disponible_ancien = Article.objects.get(id = id_article).stock_physique_disponible - detailavisrecepetion[i].quantitee_recu
			stock_physique_disponible_a_la_vente_ancien = Article.objects.get(id = id_article).stock_physique_disponible_a_la_vente - detailavisrecepetion[i].quantitee_recu 
			quantitee_ancien = Lot.objects.get(id = id_lot).quantitee - detailavisrecepetion[i].quantitee_recu

			Article.objects.filter(id = id_article).update(stock_physique_disponible = stock_physique_disponible_ancien )
			Article.objects.filter(id = id_article).update(stock_physique_disponible_a_la_vente = stock_physique_disponible_a_la_vente_ancien)
			Lot.objects.filter(id = id_lot).update(quantitee = quantitee_ancien)
			DetailRetour.objects.filter(id = detailsretour.id ).update(quantitee_recu = new_quantitee_recu)		
			DetailRetour.objects.filter(id = detailsretour.id ).update(quantitee_renvoyee_quantitee_recu= detailsretour.quantitee_renvoyee - new_quantitee_recu) 
			

		Retour.objects.filter(id = retour.id).update(quantitee_recu = new_quantitee_recu_retour)
		quantitee_renvoyee = Retour.objects.get(id = retour.id).quantitee_renvoyee
		quantitee_recu_retour_nouvelle = Retour.objects.get(id = retour.id).quantitee_recu
		
		if quantitee_recu_retour_nouvelle == 0 :
			Retour.objects.filter(id = retour.id).update(staut_reception = " ")
		elif quantitee_renvoyee > quantitee_recu_retour_nouvelle:
			Retour.objects.filter(id = retour.id).update(staut_reception = "Partiellement")
		else:
			if quantitee_renvoyee == quantitee_recu_retour_nouvelle:
				Retour.objects.filter(id = retour.id).update(staut_reception = "Complettement reçu")
			
		avis_de_reception.delete()
		messages.info(request, 'Retour sur vente a été bien supprimé')

	return redirect('liste_retours')










